#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.1.0'
__CHEETAH_versionTuple__ = (3, 1, 0, 'final', 1)
__CHEETAH_src__ = 'spec.tmpl'
__CHEETAH_srcLastModified__ = 'Fri Mar 20 01:10:55 2015'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class spec(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(spec, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def arch_line(self, value, pre='', post='', **KWS):



        ## CHEETAH: generated from #def arch_line($value, $pre='', $post='') at line 11, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        rarch, arch, value = VFSL([locals()]+SL+[globals(), builtin],"arch_split",False)(VFSL([locals()]+SL+[globals(), builtin],"value",True))
        if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 13, col 1
            write(u'''%ifarch ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"arch",True) # u'$arch' on line 14, col 9
            if _v is not None: write(_filter(_v, rawExpr=u'$arch')) # from line 14, col 9.
            write(u'''
''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"pre",True) # u'${pre}' on line 16, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${pre}')) # from line 16, col 1.
        _v = VFSL([locals()]+SL+[globals(), builtin],"value",True) # u'${value}' on line 16, col 7
        if _v is not None: write(_filter(_v, rawExpr=u'${value}')) # from line 16, col 7.
        _v = VFSL([locals()]+SL+[globals(), builtin],"post",True) # u'${post}' on line 16, col 15
        if _v is not None: write(_filter(_v, rawExpr=u'${post}')) # from line 16, col 15.
        if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 17, col 1
            write(u'''
%endif''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''# 
# Do NOT Edit the Auto-generated Part!
# Generated by: spectacle version ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.MyVersion",True) # u'${metadata.MyVersion}' on line 3, col 35
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.MyVersion}')) # from line 3, col 35.
        write(u'''
# 

Name:       ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Name",True) # u'${metadata.Name}' on line 6, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Name}')) # from line 6, col 13.
        write(u'''

''')
        # 
        #  Pre-defined const and functions
        str_newline = '\n'
        #  Macros
        write(u'''# >> macros
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("macros") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.macros",True),"has_key",False)("main"): # generated from line 25, col 1
            _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.macros.main",True)) # u'$str_newline.join($extra.content.macros.main)' on line 26, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.macros.main)')) # from line 26, col 1.
            write(u'''
''')
        write(u'''# << macros
''')
        if VFSL([locals()]+SL+[globals(), builtin],"extra.HasStatic",True): # generated from line 29, col 1
            write(u'''%define keepstatic 1
''')
            cfgstatic = ""
        else: # generated from line 32, col 1
            cfgstatic = "--disable-static"
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Macros"): # generated from line 35, col 1
            for macro_key,macro_value in VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata.Macros",True),"items",False)(): # generated from line 36, col 1
                write(u'''%define ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"macro_key",True) # u'$macro_key' on line 37, col 9
                if _v is not None: write(_filter(_v, rawExpr=u'$macro_key')) # from line 37, col 9.
                write(u''' ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"macro_value",True) # u'$macro_value' on line 37, col 20
                if _v is not None: write(_filter(_v, rawExpr=u'$macro_value')) # from line 37, col 20.
                write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)('Builder'): # generated from line 40, col 1
            Builder = VFSL([locals()]+SL+[globals(), builtin],"metadata.Builder",True)
        else: # generated from line 42, col 1
            #  default
            Builder = 'make'
        write(u'''
''')
        if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'python': # generated from line 47, col 1
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("BuildArch") and VFSL([locals()]+SL+[globals(), builtin],"metadata.BuildArch",True) == 'noarch': # generated from line 48, col 1
                write(u'''%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
''')
            else: # generated from line 50, col 1
                write(u'''%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
''')
        write(u'''Summary:    ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Summary",True) # u'${metadata.Summary}' on line 54, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Summary}')) # from line 54, col 13.
        write(u'''
Version:    ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Version",True) # u'${metadata.Version}' on line 55, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Version}')) # from line 55, col 13.
        write(u'''
Release:    ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Release",True) # u'${metadata.Release}' on line 56, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Release}')) # from line 56, col 13.
        write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Epoch"): # generated from line 57, col 1
            write(u'''Epoch:      ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Epoch",True) # u'${metadata.Epoch}' on line 58, col 13
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Epoch}')) # from line 58, col 13.
            write(u'''
''')
            auto_depend = "%{epoch}:%{version}-%{release}"
        else: # generated from line 60, col 1
            auto_depend = "%{version}-%{release}"
        write(u'''Group:      ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Group",True) # u'${metadata.Group}' on line 63, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Group}')) # from line 63, col 13.
        write(u'''
License:    ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.License",True) # u'${metadata.License}' on line 64, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.License}')) # from line 64, col 13.
        write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("ExclusiveArch"): # generated from line 65, col 1
            write(u'''ExclusiveArch:  ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.ExclusiveArch",True) # u'${metadata.ExclusiveArch}' on line 66, col 17
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.ExclusiveArch}')) # from line 66, col 17.
            write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("BuildArch"): # generated from line 68, col 1
            write(u'''BuildArch:  ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.BuildArch",True) # u'${metadata.BuildArch}' on line 69, col 13
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.BuildArch}')) # from line 69, col 13.
            write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Prefix"): # generated from line 71, col 1
            write(u'''Prefix:  ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Prefix",True) # u'${metadata.Prefix}' on line 72, col 10
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Prefix}')) # from line 72, col 10.
            write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("URL"): # generated from line 74, col 1
            write(u'''URL:        ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.URL",True) # u'${metadata.URL}' on line 75, col 13
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.URL}')) # from line 75, col 13.
            write(u'''
''')
        #  Sources
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Sources"): # generated from line 78, col 1
            idx = 0
            for source in VFSL([locals()]+SL+[globals(), builtin],"metadata.Sources",True): # generated from line 80, col 1
                write(u'''Source''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"idx",True) # u'${idx}' on line 81, col 7
                if _v is not None: write(_filter(_v, rawExpr=u'${idx}')) # from line 81, col 7.
                write(u''':    ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"source",True) # u'$source' on line 81, col 18
                if _v is not None: write(_filter(_v, rawExpr=u'$source')) # from line 81, col 18.
                write(u'''
''')
                idx = VFSL([locals()]+SL+[globals(), builtin],"idx",True) + 1
        write(u'''Source100:  ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Name",True) # u'${metadata.Name}' on line 85, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Name}')) # from line 85, col 13.
        write(u'''.yaml
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RpmLintIgnore"): # generated from line 86, col 1
            write(u'''Source101:  ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Name",True) # u'${metadata.Name}' on line 87, col 13
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Name}')) # from line 87, col 13.
            write(u'''-rpmlintrc
''')
        #  Patches
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Patches"): # generated from line 90, col 1
            idx = 0
            for patch in VFSL([locals()]+SL+[globals(), builtin],"metadata.Patches",True): # generated from line 92, col 1
                _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"patch",True), "Patch%d:     "%VFSL([locals()]+SL+[globals(), builtin],"idx",True)) # u'$arch_line($patch, "Patch%d:     "%$idx)' on line 93, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($patch, "Patch%d:     "%$idx)')) # from line 93, col 1.
                write(u'''
''')
                idx = VFSL([locals()]+SL+[globals(), builtin],"idx",True) + 1
                #  each patch
        if 'NoAutoReq' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 97, col 1
            write(u'''AutoReq: 0
''')
        if 'NoAutoReqProv' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 100, col 1
            write(u'''AutoReqProv:    0
''')
        #  Requires
        if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'perl': # generated from line 104, col 1
            write(u'''Requires:   perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Requires"): # generated from line 107, col 1
            for req in VFSL([locals()]+SL+[globals(), builtin],"metadata.Requires",True): # generated from line 108, col 1
                _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"req",True), 'Requires:   ') # u"$arch_line($req, 'Requires:   ')" on line 109, col 1
                if _v is not None: write(_filter(_v, rawExpr=u"$arch_line($req, 'Requires:   ')")) # from line 109, col 1.
                write(u'''
''')
                #  each req
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RequiresPre"): # generated from line 112, col 1
            for req in VFSL([locals()]+SL+[globals(), builtin],"metadata.RequiresPre",True): # generated from line 113, col 1
                write(u'''Requires(pre): ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 114, col 16
                if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 114, col 16.
                write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RequiresPreUn"): # generated from line 117, col 1
            for req in VFSL([locals()]+SL+[globals(), builtin],"metadata.RequiresPreUn",True): # generated from line 118, col 1
                write(u'''Requires(preun): ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 119, col 18
                if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 119, col 18.
                write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RequiresPost"): # generated from line 122, col 1
            for req in VFSL([locals()]+SL+[globals(), builtin],"metadata.RequiresPost",True): # generated from line 123, col 1
                write(u'''Requires(post): ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 124, col 17
                if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 124, col 17.
                write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RequiresPostUn"): # generated from line 127, col 1
            for req in VFSL([locals()]+SL+[globals(), builtin],"metadata.RequiresPostUn",True): # generated from line 128, col 1
                write(u'''Requires(postun): ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 129, col 19
                if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 129, col 19.
                write(u'''
''')
        #  BuildRequires
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("PkgConfigBR"): # generated from line 133, col 1
            for br in VFSL([locals()]+SL+[globals(), builtin],"metadata.PkgConfigBR",True): # generated from line 134, col 1
                br_comps = VFN(VFSL([locals()]+SL+[globals(), builtin],"br",True),"split",False)()
                if VFSL([locals()]+SL+[globals(), builtin],"len",False)(VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)) > 1: # generated from line 136, col 1
                    _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)[0], "BuildRequires:  pkgconfig(", ")%s" % VFSL([locals()]+SL+[globals(), builtin],"br",True)[VFSL([locals()]+SL+[globals(), builtin],"len",False)(VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)[0]):]) # u'$arch_line($br_comps[0], "BuildRequires:  pkgconfig(", ")%s" % $br[$len($br_comps[0]):])' on line 137, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($br_comps[0], "BuildRequires:  pkgconfig(", ")%s" % $br[$len($br_comps[0]):])')) # from line 137, col 1.
                    write(u'''
''')
                else: # generated from line 138, col 1
                    _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"br",True), "BuildRequires:  pkgconfig(", ")") # u'$arch_line($br, "BuildRequires:  pkgconfig(", ")")' on line 139, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($br, "BuildRequires:  pkgconfig(", ")")')) # from line 139, col 1.
                    write(u'''
''')
                #  each br
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("PkgBR"): # generated from line 143, col 1
            for br in VFSL([locals()]+SL+[globals(), builtin],"metadata.PkgBR",True): # generated from line 144, col 1
                _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"br",True), "BuildRequires:  ") # u'$arch_line($br, "BuildRequires:  ")' on line 145, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($br, "BuildRequires:  ")')) # from line 145, col 1.
                write(u'''
''')
                #  each br
        #  BuildConflicts
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("BuildConflicts"): # generated from line 149, col 1
            for bcfl in VFSL([locals()]+SL+[globals(), builtin],"metadata.BuildConflicts",True): # generated from line 150, col 1
                write(u'''BuildConflicts: ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"bcfl",True) # u'$bcfl' on line 151, col 17
                if _v is not None: write(_filter(_v, rawExpr=u'$bcfl')) # from line 151, col 17.
                write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RunFdupes"): # generated from line 154, col 1
            write(u'''BuildRequires:  fdupes
''')
        if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'cmake': # generated from line 157, col 1
            write(u'''BuildRequires:  cmake
''')
        if 'NoAutoProv' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 160, col 1
            write(u'''AutoProv: 0
''')
        #  Provides
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Provides"): # generated from line 164, col 1
            for prd in VFSL([locals()]+SL+[globals(), builtin],"metadata.Provides",True): # generated from line 165, col 1
                write(u'''Provides:   ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"prd",True) # u'$prd' on line 166, col 13
                if _v is not None: write(_filter(_v, rawExpr=u'$prd')) # from line 166, col 13.
                write(u'''
''')
        #  Conflicts
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Conflicts"): # generated from line 170, col 1
            for cfl in VFSL([locals()]+SL+[globals(), builtin],"metadata.Conflicts",True): # generated from line 171, col 1
                write(u'''Conflicts:   ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"cfl",True) # u'$cfl' on line 172, col 14
                if _v is not None: write(_filter(_v, rawExpr=u'$cfl')) # from line 172, col 14.
                write(u'''
''')
        #  Obsoletes
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Obsoletes"): # generated from line 176, col 1
            for obs in VFSL([locals()]+SL+[globals(), builtin],"metadata.Obsoletes",True): # generated from line 177, col 1
                write(u'''Obsoletes:   ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"obs",True) # u'$obs' on line 178, col 14
                if _v is not None: write(_filter(_v, rawExpr=u'$obs')) # from line 178, col 14.
                write(u'''
''')
        if 'SupportOtherDistros' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 181, col 1
            write(u'''BuildRoot:  %{_tmppath}/%{name}-%{version}-build
''')
        write(u'''
%description
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Description"): # generated from line 186, col 1
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Description",True) # u'${metadata.Description}' on line 187, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Description}')) # from line 187, col 1.
            write(u'''
''')
        else: # generated from line 188, col 1
            write(u'''Description: %{summary}
''')
        write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("SubPackages"): # generated from line 192, col 1
            for sp in VFSL([locals()]+SL+[globals(), builtin],"metadata.SubPackages",True): # generated from line 193, col 1
                sub_extra = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra",True),"subpkgs",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("AsWholeName"): # generated from line 195, col 1
                    write(u'''%package -n ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 196, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 196, col 13.
                    write(u'''
''')
                else: # generated from line 197, col 1
                    write(u'''%package ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 198, col 10
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 198, col 10.
                    write(u'''
''')
                write(u'''Summary:    ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Summary",True) # u'$sp.Summary' on line 200, col 13
                if _v is not None: write(_filter(_v, rawExpr=u'$sp.Summary')) # from line 200, col 13.
                write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("License"): # generated from line 201, col 1
                    write(u'''License:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.License",True) # u'$sp.License' on line 202, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.License')) # from line 202, col 13.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Group"): # generated from line 204, col 1
                    write(u'''Group:      ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Group",True) # u'$sp.Group' on line 205, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Group')) # from line 205, col 13.
                    write(u'''
''')
                else: # generated from line 206, col 1
                    write(u'''Group:      ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Group",True) # u'${metadata.Group}' on line 207, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Group}')) # from line 207, col 13.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Version"): # generated from line 209, col 1
                    write(u'''Version:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Version",True) # u'$sp.Version' on line 210, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Version')) # from line 210, col 13.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Release"): # generated from line 212, col 1
                    write(u'''Release:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Release",True) # u'$sp.Release' on line 213, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Release')) # from line 213, col 13.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Epoch"): # generated from line 215, col 1
                    write(u'''Epoch:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Epoch",True) # u'$sp.Epoch' on line 216, col 11
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Epoch')) # from line 216, col 11.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("URL"): # generated from line 218, col 1
                    write(u'''URL:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.URL",True) # u'$sp.URL' on line 219, col 9
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.URL')) # from line 219, col 9.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("BuildArch"): # generated from line 221, col 1
                    write(u'''BuildArch:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.BuildArch",True) # u'$sp.BuildArch' on line 222, col 15
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.BuildArch')) # from line 222, col 15.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Prefix"): # generated from line 224, col 1
                    write(u'''Prefix:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Prefix",True) # u'$sp.Prefix' on line 225, col 12
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Prefix')) # from line 225, col 12.
                    write(u'''
''')
                if 'NoAutoReq' in VFSL([locals()]+SL+[globals(), builtin],"sp",True): # generated from line 227, col 1
                    write(u'''AutoReq:    0
''')
                if 'NoAutoProv' in VFSL([locals()]+SL+[globals(), builtin],"sp",True): # generated from line 230, col 1
                    write(u'''AutoProv:    0
''')
                if 'NoAutoReqProv' in VFSL([locals()]+SL+[globals(), builtin],"sp",True): # generated from line 233, col 1
                    write(u'''AutoReqProv:    0
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("AutoDepend") and not VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("NoFiles"): # generated from line 236, col 1
                    write(u'''Requires:   %{name} = ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"auto_depend",True) # u'$auto_depend' on line 237, col 23
                    if _v is not None: write(_filter(_v, rawExpr=u'$auto_depend')) # from line 237, col 23.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Requires"): # generated from line 239, col 1
                    for req in VFSL([locals()]+SL+[globals(), builtin],"sp.Requires",True): # generated from line 240, col 1
                        _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"req",True), "Requires:   ") # u'$arch_line($req, "Requires:   ")' on line 241, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($req, "Requires:   ")')) # from line 241, col 1.
                        write(u'''
''')
                        #  each req
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("RequiresPre"): # generated from line 244, col 1
                    for req in VFSL([locals()]+SL+[globals(), builtin],"sp.RequiresPre",True): # generated from line 245, col 1
                        write(u'''Requires(pre): ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 246, col 16
                        if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 246, col 16.
                        write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("RequiresPreUn"): # generated from line 249, col 1
                    for req in VFSL([locals()]+SL+[globals(), builtin],"sp.RequiresPreUn",True): # generated from line 250, col 1
                        write(u'''Requires(preun): ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 251, col 18
                        if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 251, col 18.
                        write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("RequiresPost"): # generated from line 254, col 1
                    for req in VFSL([locals()]+SL+[globals(), builtin],"sp.RequiresPost",True): # generated from line 255, col 1
                        write(u'''Requires(post): ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 256, col 17
                        if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 256, col 17.
                        write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("RequiresPostUn"): # generated from line 259, col 1
                    for req in VFSL([locals()]+SL+[globals(), builtin],"sp.RequiresPostUn",True): # generated from line 260, col 1
                        write(u'''Requires(postun): ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 261, col 19
                        if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 261, col 19.
                        write(u'''
''')
                #  Provides
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Provides"): # generated from line 265, col 1
                    for prd in VFSL([locals()]+SL+[globals(), builtin],"sp.Provides",True): # generated from line 266, col 1
                        write(u'''Provides:   ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"prd",True) # u'$prd' on line 267, col 13
                        if _v is not None: write(_filter(_v, rawExpr=u'$prd')) # from line 267, col 13.
                        write(u'''
''')
                #  Conflicts
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Conflicts"): # generated from line 271, col 1
                    for cfl in VFSL([locals()]+SL+[globals(), builtin],"sp.Conflicts",True): # generated from line 272, col 1
                        write(u'''Conflicts:   ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"cfl",True) # u'$cfl' on line 273, col 14
                        if _v is not None: write(_filter(_v, rawExpr=u'$cfl')) # from line 273, col 14.
                        write(u'''
''')
                #  Obsoletes
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Obsoletes"): # generated from line 277, col 1
                    for obs in VFSL([locals()]+SL+[globals(), builtin],"sp.Obsoletes",True): # generated from line 278, col 1
                        write(u'''Obsoletes:   ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"obs",True) # u'$obs' on line 279, col 14
                        if _v is not None: write(_filter(_v, rawExpr=u'$obs')) # from line 279, col 14.
                        write(u'''
''')
                #  BR
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("PkgBR"): # generated from line 283, col 1
                    for br in VFSL([locals()]+SL+[globals(), builtin],"sp.PkgBR",True): # generated from line 284, col 1
                        _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"br",True), "BuildRequires:   ") # u'$arch_line($br, "BuildRequires:   ")' on line 285, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($br, "BuildRequires:   ")')) # from line 285, col 1.
                        write(u'''
''')
                        #  each br
                #  PkgConfigBR
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("PkgConfigBR"): # generated from line 289, col 1
                    for br in VFSL([locals()]+SL+[globals(), builtin],"sp.PkgConfigBR",True): # generated from line 290, col 1
                        br_comps = VFN(VFSL([locals()]+SL+[globals(), builtin],"br",True),"split",False)()
                        if VFSL([locals()]+SL+[globals(), builtin],"len",False)(VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)) > 1: # generated from line 292, col 1
                            _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)[0], "BuildRequires:  pkgconfig(", ")%s" % VFSL([locals()]+SL+[globals(), builtin],"br",True)[VFSL([locals()]+SL+[globals(), builtin],"len",False)(VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)[0]):]) # u'$arch_line($br_comps[0], "BuildRequires:  pkgconfig(", ")%s" % $br[$len($br_comps[0]):])' on line 293, col 1
                            if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($br_comps[0], "BuildRequires:  pkgconfig(", ")%s" % $br[$len($br_comps[0]):])')) # from line 293, col 1.
                            write(u'''
''')
                        else: # generated from line 294, col 1
                            _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"br",True), "BuildRequires:  pkgconfig(", ")") # u'$arch_line($br, "BuildRequires:  pkgconfig(", ")")' on line 295, col 1
                            if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($br, "BuildRequires:  pkgconfig(", ")")')) # from line 295, col 1.
                            write(u'''
''')
                        #  each br
                #  BuildConflicts
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("BuildConflicts"): # generated from line 300, col 1
                    for bcfl in VFSL([locals()]+SL+[globals(), builtin],"sp.BuildConflicts",True): # generated from line 301, col 1
                        write(u'''BuildConflicts: ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"bcfl",True) # u'$bcfl' on line 302, col 17
                        if _v is not None: write(_filter(_v, rawExpr=u'$bcfl')) # from line 302, col 17.
                        write(u'''
''')
                write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("AsWholeName"): # generated from line 306, col 1
                    write(u'''%description -n ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 307, col 17
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 307, col 17.
                    write(u'''
''')
                else: # generated from line 308, col 1
                    write(u'''%description ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 309, col 14
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 309, col 14.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)('Description'): # generated from line 311, col 1
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Description",True) # u'$sp.Description' on line 312, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Description')) # from line 312, col 1.
                    write(u'''
''')
                else: # generated from line 313, col 1
                    write(u'''Description: %{summary}
''')
                write(u'''
''')
        #  Macros2
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Macros2") or VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("macros2"): # generated from line 321, col 1
            write(u'''
''')
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("macros2") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.macros2",True),"has_key",False)("main") and VFSL([locals()]+SL+[globals(), builtin],"extra.content.macros2.main",True): # generated from line 323, col 1
                write(u'''# >> macros2
''')
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.macros2.main",True)) # u'$str_newline.join($extra.content.macros2.main)' on line 325, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.macros2.main)')) # from line 325, col 1.
                write(u'''
# << macros2
''')
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Macros2"): # generated from line 328, col 1
                for macro_key,macro_value in VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata.Macros2",True),"items",False)(): # generated from line 329, col 1
                    write(u'''%define ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"macro_key",True) # u'$macro_key' on line 330, col 9
                    if _v is not None: write(_filter(_v, rawExpr=u'$macro_key')) # from line 330, col 9.
                    write(u''' ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"macro_value",True) # u'$macro_value' on line 330, col 20
                    if _v is not None: write(_filter(_v, rawExpr=u'$macro_value')) # from line 330, col 20.
                    write(u'''
''')
        write(u'''
''')
        # ########################## prep scripts
        write(u'''%prep
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Sources"): # generated from line 337, col 1
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("NoSetup"): # generated from line 338, col 1
                write(u'''# No setup
''')
            elif VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("SetupOptions"): # generated from line 340, col 1
                write(u'''%setup ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.SetupOptions",True) # u'$metadata.SetupOptions' on line 341, col 8
                if _v is not None: write(_filter(_v, rawExpr=u'$metadata.SetupOptions')) # from line 341, col 8.
                write(u'''
''')
            else: # generated from line 342, col 1
                write(u'''%setup -q -n ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.SourcePrefix",True) # u'$metadata.SourcePrefix' on line 343, col 14
                if _v is not None: write(_filter(_v, rawExpr=u'$metadata.SourcePrefix')) # from line 343, col 14.
                write(u'''
''')
            write(u'''
''')
            #  has Sources
        #  Applying patches
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Patches"): # generated from line 348, col 1
            idx = 0
            for patch in VFSL([locals()]+SL+[globals(), builtin],"metadata.Patches",True): # generated from line 350, col 1
                if "PatchCmts" in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 351, col 1
                    _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"PatchCmts",True)[VFSL([locals()]+SL+[globals(), builtin],"idx",True)] # u'$metadata.PatchCmts[$idx]' on line 352, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$metadata.PatchCmts[$idx]')) # from line 352, col 1.
                    write(u'''
''')
                if 'PatchOpts' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 354, col 1
                    _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"patch",True), "# ", "\n%%patch%d %s"%(VFSL([locals()]+SL+[globals(), builtin],"idx",True), VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"PatchOpts",True)[VFSL([locals()]+SL+[globals(), builtin],"idx",True)])) # u'$arch_line($patch, "# ", "\\n%%patch%d %s"%($idx, $metadata.PatchOpts[$idx]))' on line 355, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($patch, "# ", "\\n%%patch%d %s"%($idx, $metadata.PatchOpts[$idx]))')) # from line 355, col 1.
                    write(u'''
''')
                else: # generated from line 356, col 1
                    _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"patch",True), "# ", "\n%%patch%d -p1"%VFSL([locals()]+SL+[globals(), builtin],"idx",True)) # u'$arch_line($patch, "# ", "\\n%%patch%d -p1"%$idx)' on line 357, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($patch, "# ", "\\n%%patch%d -p1"%$idx)')) # from line 357, col 1.
                    write(u'''
''')
                idx = VFSL([locals()]+SL+[globals(), builtin],"idx",True) + 1
                #  each patch
        write(u'''# >> setup
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("setup") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.setup",True),"has_key",False)("main"): # generated from line 363, col 1
            _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.setup.main",True)) # u'$str_newline.join($extra.content.setup.main)' on line 364, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.setup.main)')) # from line 364, col 1.
            write(u'''
''')
        write(u'''# << setup

''')
        # ########################## build scripts
        write(u'''%build
''')
        if not VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)('UseAsNeeded'): # generated from line 370, col 1
            write(u'''unset LD_AS_NEEDED
''')
        write(u'''# >> build pre
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("build") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.build",True),"has_key",False)("pre"): # generated from line 374, col 1
            _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.build.pre",True)) # u'$str_newline.join($extra.content.build.pre)' on line 375, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.build.pre)')) # from line 375, col 1.
            write(u'''
''')
        write(u'''# << build pre

''')
        if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'python': # generated from line 380, col 1
            write(u'''CFLAGS="$RPM_OPT_FLAGS" %{__python} setup.py build
''')
        elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'qmake': # generated from line 382, col 1
            Configure = 'none'
            if 'SupportOtherDistros' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 384, col 1
                write(u'''%if 0%{?moblin_version}
%qmake ''')
                if 'QMakeOptions' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 387, col 1
                    write(u''' \\
''')
                else: # generated from line 389, col 1
                    write(u'''
''')
                write(u'''%else
qmake -makefile -nocache \\
  "QMAKE_CFLAGS_RELEASE=${CFLAGS:-%optflags}" \\
  "QMAKE_CFLAGS_DEBUG=${CFLAGS:-%optflags}" \\
  "QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS:-%optflags}" \\
  "QMAKE_CXXFLAGS_DEBUG=${CXXFLAGS:-%optflags}" \\
  QMAKE_STRIP=: \\
  PREFIX=%{_prefix} ''')
                if 'QMakeOptions' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 400, col 1
                    write(u''' \\
''')
                else: # generated from line 402, col 1
                    write(u'''
''')
                write(u'''%endif
''')
            else: # generated from line 406, col 1
                write(u'''%qmake ''')
                if 'QMakeOptions' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 408, col 1
                    write(u''' \\
''')
                else: # generated from line 410, col 1
                    write(u'''
''')
            if 'QMakeOptions' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 414, col 1
                length = len(VFSL([locals()]+SL+[globals(), builtin],"metadata.QMakeOptions",True))
                idx = 1
                for opt in VFSL([locals()]+SL+[globals(), builtin],"metadata.QMakeOptions",True): # generated from line 417, col 1
                    if VFSL([locals()]+SL+[globals(), builtin],"idx",True) == VFSL([locals()]+SL+[globals(), builtin],"length",True): # generated from line 418, col 1
                        _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"opt",True), "    ") # u'$arch_line($opt, "    ")' on line 419, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($opt, "    ")')) # from line 419, col 1.
                        write(u'''
''')
                    else: # generated from line 420, col 1
                        _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"opt",True), "    ", " \\") # u'$arch_line($opt, "    ", " \\\\")' on line 421, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($opt, "    ", " \\\\")')) # from line 421, col 1.
                        write(u'''
''')
                    idx = VFSL([locals()]+SL+[globals(), builtin],"idx",True) + 1
                #  QMakeOptions
            write(u'''
make %{?jobs:-j%jobs}
''')
        elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'perl': # generated from line 428, col 1
            write(u'''if test -f Makefile.PL; then
%{__perl} Makefile.PL INSTALLDIRS=vendor
make %{?jobs:-j%jobs}
else
%{__perl} Build.PL  --installdirs vendor
./Build
fi
''')
        else: # generated from line 436, col 1
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)('Configure'): # generated from line 438, col 1
                Configure = VFSL([locals()]+SL+[globals(), builtin],"metadata.Configure",True)
            else: # generated from line 441, col 1
                #  default
                if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'cmake': # generated from line 443, col 1
                    Configure = 'cmake'
                else: # generated from line 445, col 1
                    Configure = 'configure'
            if VFSL([locals()]+SL+[globals(), builtin],"Configure",True) == 'autogen': # generated from line 450, col 1
                write(u'''%autogen ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"cfgstatic",True) # u'$cfgstatic' on line 451, col 10
                if _v is not None: write(_filter(_v, rawExpr=u'$cfgstatic')) # from line 451, col 10.
                write(u'''
%configure ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"cfgstatic",True) # u'$cfgstatic' on line 452, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'$cfgstatic')) # from line 452, col 12.
            elif VFSL([locals()]+SL+[globals(), builtin],"Configure",True) == 'cmake': # generated from line 453, col 1
                write(u'''%cmake . ''')
            elif VFSL([locals()]+SL+[globals(), builtin],"Configure",True) == 'configure': # generated from line 455, col 1
                write(u'''%configure ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"cfgstatic",True) # u'$cfgstatic' on line 456, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'$cfgstatic')) # from line 456, col 12.
            elif VFSL([locals()]+SL+[globals(), builtin],"Configure",True) == 'reconfigure': # generated from line 457, col 1
                write(u'''%reconfigure ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"cfgstatic",True) # u'$cfgstatic' on line 458, col 14
                if _v is not None: write(_filter(_v, rawExpr=u'$cfgstatic')) # from line 458, col 14.
            #  any other values fall thru to 'noconfigure'
            if ( VFSL([locals()]+SL+[globals(), builtin],"Configure",True) != 'noconfigure' or VFSL([locals()]+SL+[globals(), builtin],"Configure",True) != 'none' ) and VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("ConfigOptions"): # generated from line 461, col 1
                write(u''' \\
''')
                length = len(VFSL([locals()]+SL+[globals(), builtin],"metadata.ConfigOptions",True))
                idx = 1
                for opt in VFSL([locals()]+SL+[globals(), builtin],"metadata.ConfigOptions",True): # generated from line 465, col 1
                    #  checking arch namespace prefix
                    if VFSL([locals()]+SL+[globals(), builtin],"idx",True) == VFSL([locals()]+SL+[globals(), builtin],"length",True): # generated from line 467, col 1
                        _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"opt",True), "    ") # u'$arch_line($opt, "    ")' on line 468, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($opt, "    ")')) # from line 468, col 1.
                        write(u'''
''')
                    else: # generated from line 469, col 1
                        _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"opt",True), "    ", " \\") # u'$arch_line($opt, "    ", " \\\\")' on line 470, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($opt, "    ", " \\\\")')) # from line 470, col 1.
                        write(u'''
''')
                    idx = VFSL([locals()]+SL+[globals(), builtin],"idx",True) + 1
                #  ConfigOptions
            write(u'''
''')
            if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'make' or VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'cmake': # generated from line 476, col 1
                write(u'''make %{?jobs:-j%jobs}
''')
            elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'single-make': # generated from line 478, col 1
                write(u'''make
''')
            elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) != 'no-make' and VFSL([locals()]+SL+[globals(), builtin],"Builder",True) != 'none' and VFSL([locals()]+SL+[globals(), builtin],"Builder",True) != 'no-builder': # generated from line 480, col 1
                _v = VFSL([locals()]+SL+[globals(), builtin],"Builder",True) # u'$Builder' on line 481, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$Builder')) # from line 481, col 1.
                write(u'''
''')
            #  Builder == python
        write(u'''
# >> build post
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("build") and  VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.build",True),"has_key",False)("post"): # generated from line 487, col 1
            _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.build.post",True)) # u'$str_newline.join($extra.content.build.post)' on line 488, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.build.post)')) # from line 488, col 1.
            write(u'''
''')
        write(u'''# << build post

''')
        # ########################## installation scripts
        write(u'''%install
''')
        if 'SupportOtherDistros' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 494, col 1
            write(u'''rm -rf $RPM_BUILD_ROOT
''')
        else: # generated from line 496, col 1
            write(u'''rm -rf %{buildroot}
''')
        write(u'''# >> install pre
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("install") and  VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.install",True),"has_key",False)("pre"): # generated from line 500, col 1
            _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.install.pre",True)) # u'$str_newline.join($extra.content.install.pre)' on line 501, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.install.pre)')) # from line 501, col 1.
            write(u'''
''')
        write(u'''# << install pre
''')
        if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'python': # generated from line 504, col 1
            if 'SupportOtherDistros' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 505, col 1
                write(u'''%if 0%{?suse_version}
%{__python} setup.py install --root=$RPM_BUILD_ROOT --prefix=%{_prefix}
%else
%{__python} setup.py install --root=$RPM_BUILD_ROOT -O1
%endif
''')
            else: # generated from line 511, col 1
                write(u'''%{__python} setup.py install --root=%{buildroot} -O1
''')
        elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'perl': # generated from line 514, col 1
            write(u"""if test -f Makefile.PL; then
make pure_install PERL_INSTALL_ROOT=%{buildroot}
else
./Build install --installdirs vendor
fi
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -depth -type d -exec rmdir {} 2>/dev/null ';'
find %{buildroot} -type f -name '*.bs' -empty -exec rm -f {} ';'
%{_fixperms} %{buildroot}/*
""")
        elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'qmake': # generated from line 524, col 1
            if 'SupportOtherDistros' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 525, col 1
                write(u'''%if 0%{?moblin_version}
%qmake_install
%else
%makeinstall
%endif
''')
            else: # generated from line 531, col 1
                write(u'''%qmake_install
''')
        elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'make' or VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'single-make' or VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'cmake': # generated from line 534, col 1
            if 'SupportOtherDistros' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 535, col 1
                write(u'''%if 0%{?moblin_version}
%make_install
%else
%makeinstall
%endif
''')
            else: # generated from line 541, col 1
                write(u'''%make_install
''')
                #  SupportOtherDistros
            #  of Builder == 'make' ...
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("ExtraInstall"): # generated from line 545, col 1
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.ExtraInstall",True) # u'$metadata.ExtraInstall' on line 546, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$metadata.ExtraInstall')) # from line 546, col 1.
            write(u'''
''')
        write(u'''
# >> install post
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("install") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.install",True),"has_key",False)("post"): # generated from line 550, col 1
            _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.install.post",True)) # u'$str_newline.join($extra.content.install.post)' on line 551, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.install.post)')) # from line 551, col 1.
            write(u'''
''')
        write(u'''# << install post

''')
        if VFSL([locals()]+SL+[globals(), builtin],"extra.Desktop",True): # generated from line 555, col 1
            write(u'''desktop-file-install --delete-original       \\
  --dir %{buildroot}%{_datadir}/applications             \\
   %{buildroot}%{_datadir}/applications/*.desktop
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("LocaleName"): # generated from line 560, col 1
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("LocaleOptions"): # generated from line 561, col 1
                localeopt_str = VFSL([locals()]+SL+[globals(), builtin],"metadata",True)["LocaleOptions"]
                write(u'''%find_lang ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.LocaleName",True) # u'${metadata.LocaleName}' on line 563, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'${metadata.LocaleName}')) # from line 563, col 12.
                write(u''' ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"localeopt_str",True) # u'$localeopt_str' on line 563, col 35
                if _v is not None: write(_filter(_v, rawExpr=u'$localeopt_str')) # from line 563, col 35.
                write(u'''
''')
            else: # generated from line 564, col 1
                write(u'''%find_lang ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.LocaleName",True) # u'${metadata.LocaleName}' on line 565, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'${metadata.LocaleName}')) # from line 565, col 12.
                write(u'''
''')
        # ########################## run fdupes
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RunFdupes"): # generated from line 569, col 1
            for fditem in VFSL([locals()]+SL+[globals(), builtin],"metadata.RunFdupes",True): # generated from line 570, col 1
                write(u'''%fdupes  %{buildroot}/''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"fditem",True) # u'$fditem' on line 571, col 23
                if _v is not None: write(_filter(_v, rawExpr=u'$fditem')) # from line 571, col 23.
                write(u'''
''')
        # ########################## optional check scripts
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Check"): # generated from line 575, col 1
            write(u'''
%check
# >> check
''')
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("check"): # generated from line 579, col 1
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.check.main",True)) # u'$str_newline.join($extra.content.check.main)' on line 580, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.check.main)')) # from line 580, col 1.
                write(u'''
''')
            else: # generated from line 581, col 1
                if  VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'perl': # generated from line 582, col 1
                    write(u'''if test -f Makefile.PL; then
make test
else
./Build test
fi
''')
                else: # generated from line 588, col 1
                    write(u'''make check
''')
            write(u'''# << check
''')
        # ########################## Pre
        has_extra_pre = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("pre") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.pre",True),"has_key",False)("main")
        if VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_pre",True): # generated from line 596, col 1
            write(u'''
%pre
''')
            #  -Schema
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True): # generated from line 600, col 1
                write(u'''if [ "$1" -gt 1 ]; then
''')
                for schema in VFSL([locals()]+SL+[globals(), builtin],"extra.Schemas",True): # generated from line 602, col 1
                    write(u'''  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule \\
    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"schema",True) # u'$schema' on line 605, col 5
                    if _v is not None: write(_filter(_v, rawExpr=u'$schema')) # from line 605, col 5.
                    write(u''' \\
    > /dev/null || :
''')
                write(u'''fi
''')
            #  -Extra pre
            if VFSL([locals()]+SL+[globals(), builtin],"has_extra_pre",True): # generated from line 611, col 1
                write(u'''# >> pre
''')
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.pre.main",True)) # u'$str_newline.join($extra.content.pre.main)' on line 613, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.pre.main)')) # from line 613, col 1.
                write(u'''
# << pre
''')
        # ########################## PreUn
        has_extra_preun = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("preun") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.preun",True),"has_key",False)("main")
        if VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.SystemdService",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_preun",True): # generated from line 619, col 1
            write(u'''
%preun
''')
            #  -Schema
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True): # generated from line 623, col 1
                write(u'''if [ "$1" -eq 0 ]; then
''')
                for schema in VFSL([locals()]+SL+[globals(), builtin],"extra.Schemas",True): # generated from line 625, col 1
                    write(u'''  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule \\
    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"schema",True) # u'$schema' on line 628, col 5
                    if _v is not None: write(_filter(_v, rawExpr=u'$schema')) # from line 628, col 5.
                    write(u''' \\
    > /dev/null || :
''')
                write(u'''fi
''')
            #  -SystemdService (systemd)
            if VFSL([locals()]+SL+[globals(), builtin],"extra.SystemdService",True): # generated from line 634, col 1
                write(u'''if [ "$1" -eq 0 ]; then
''')
                for srv in VFSL([locals()]+SL+[globals(), builtin],"extra.SystemdServices",True): # generated from line 636, col 1
                    write(u'''systemctl stop ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"srv",True) # u'$srv' on line 637, col 16
                    if _v is not None: write(_filter(_v, rawExpr=u'$srv')) # from line 637, col 16.
                    write(u'''
''')
                write(u'''fi
''')
            #  -Extra preun
            if VFSL([locals()]+SL+[globals(), builtin],"has_extra_preun",True): # generated from line 642, col 1
                write(u'''# >> preun
''')
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.preun.main",True)) # u'$str_newline.join($extra.content.preun.main)' on line 644, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.preun.main)')) # from line 644, col 1.
                write(u'''
# << preun
''')
        # ########################## Post
        has_extra_post = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("post") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.post",True),"has_key",False)("main") and VFSL([locals()]+SL+[globals(), builtin],"extra.content.post.main",True)
        if VFSL([locals()]+SL+[globals(), builtin],"extra.Lib",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.SystemdService",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_post",True): # generated from line 650, col 1
            write(u'''
''')
            only_Lib = not (VFSL([locals()]+SL+[globals(), builtin],"extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.SystemdService",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_post",True))
            if VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 653, col 1
                write(u'''%post -p /sbin/ldconfig
''')
            else: # generated from line 655, col 1
                write(u'''%post
''')
            #  -Lib
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Lib",True) and not VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 659, col 1
                write(u'''/sbin/ldconfig
''')
            #  -Schema
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True): # generated from line 663, col 1
                for schema in VFSL([locals()]+SL+[globals(), builtin],"extra.Schemas",True): # generated from line 664, col 1
                    write(u'''export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule \\
    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"schema",True) # u'$schema' on line 667, col 5
                    if _v is not None: write(_filter(_v, rawExpr=u'$schema')) # from line 667, col 5.
                    write(u'''  > /dev/null || :
''')
            #  -Info
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Info",True): # generated from line 671, col 1
                for inf in VFSL([locals()]+SL+[globals(), builtin],"extra.Infos",True): # generated from line 672, col 1
                    write(u'''%install_info --info-dir=%_infodir ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"inf",True) # u'$inf' on line 673, col 36
                    if _v is not None: write(_filter(_v, rawExpr=u'$inf')) # from line 673, col 36.
                    write(u'''
''')
            #  -Icon
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Icon",True): # generated from line 677, col 1
                write(u'''/bin/touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache \\
  --quiet %{_datadir}/icons/hicolor 2> /dev/null|| :
''')
            #  -DesktopDB
            if VFSL([locals()]+SL+[globals(), builtin],"extra.DesktopDB",True): # generated from line 683, col 1
                write(u'''update-desktop-database %{_datadir}/applications &> /dev/null || :
''')
            #  -SystemdService (systemd)
            if VFSL([locals()]+SL+[globals(), builtin],"extra.SystemdService",True): # generated from line 687, col 1
                write(u'''systemctl daemon-reload
''')
                for srv in VFSL([locals()]+SL+[globals(), builtin],"extra.SystemdServices",True): # generated from line 689, col 1
                    write(u'''systemctl reload-or-try-restart ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"srv",True) # u'$srv' on line 690, col 33
                    if _v is not None: write(_filter(_v, rawExpr=u'$srv')) # from line 690, col 33.
                    write(u'''
''')
            #  -Extra Post Script
            if VFSL([locals()]+SL+[globals(), builtin],"has_extra_post",True): # generated from line 694, col 1
                write(u'''# >> post
''')
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.post.main",True)) # u'$str_newline.join($extra.content.post.main)' on line 696, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.post.main)')) # from line 696, col 1.
                write(u'''
# << post
''')
            #  need post
        # ########################## PostUn
        has_extra_postun = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("postun") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.postun",True),"has_key",False)("main") and VFSL([locals()]+SL+[globals(), builtin],"extra.content.postun.main",True)
        if VFSL([locals()]+SL+[globals(), builtin],"extra.Lib",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.SystemdService",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_postun",True): # generated from line 702, col 1
            write(u'''
''')
            only_Lib = not (VFSL([locals()]+SL+[globals(), builtin],"extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.SystemdService",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_postun",True))
            if VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 705, col 1
                write(u'''%postun -p /sbin/ldconfig
''')
            else: # generated from line 707, col 1
                write(u'''%postun
''')
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Lib",True) and not VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 710, col 1
                write(u'''/sbin/ldconfig
''')
            #  -Info
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Info",True): # generated from line 714, col 1
                write(u'''if [ $1 = 0 ] ;then
''')
                for inf in VFSL([locals()]+SL+[globals(), builtin],"extra.Infos",True): # generated from line 716, col 1
                    write(u'''%install_info_delete --info-dir=%{_infodir} ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"inf",True) # u'$inf' on line 717, col 45
                    if _v is not None: write(_filter(_v, rawExpr=u'$inf')) # from line 717, col 45.
                    write(u'''
''')
                write(u'''fi
''')
            #  -Icon
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Icon",True): # generated from line 722, col 1
                write(u'''/bin/touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache \\
  --quiet %{_datadir}/icons/hicolor 2> /dev/null|| :
''')
            #  -DesktopDB
            if VFSL([locals()]+SL+[globals(), builtin],"extra.DesktopDB",True): # generated from line 728, col 1
                write(u'''update-desktop-database %{_datadir}/applications &> /dev/null || :
''')
            #  -SystemdService (systemd)
            if VFSL([locals()]+SL+[globals(), builtin],"extra.SystemdService",True): # generated from line 732, col 1
                write(u'''systemctl daemon-reload
''')
            #  -Extra Postun Script
            if VFSL([locals()]+SL+[globals(), builtin],"has_extra_postun",True): # generated from line 736, col 1
                write(u'''# >> postun
''')
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.postun.main",True)) # u'$str_newline.join($extra.content.postun.main)' on line 738, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.postun.main)')) # from line 738, col 1.
                write(u'''
# << postun
''')
            #  need postun
        #  Pre/Preun/Post/Postun for SubPackages
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("SubPackages"): # generated from line 744, col 1
            for sp in VFSL([locals()]+SL+[globals(), builtin],"metadata.SubPackages",True): # generated from line 745, col 1
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("AsWholeName"): # generated from line 746, col 1
                    pkg_name = "-n " + VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)
                else: # generated from line 748, col 1
                    pkg_name = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)
                sub_extra = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra",True),"subpkgs",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]
                #  Pre for SubPackages
                has_extra_pre = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("pre") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.pre",True),"has_key",False)(VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True))
                if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_pre",True): # generated from line 755, col 1
                    write(u'''
%pre ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 757, col 6
                    if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 757, col 6.
                    write(u'''
''')
                    #  -Schema
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True): # generated from line 759, col 1
                        write(u'''if [ "$1" -gt 1 ]; then
''')
                        for schema in VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schemas",True): # generated from line 761, col 1
                            write(u'''  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule \\
    ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"schema",True) # u'$schema' on line 764, col 5
                            if _v is not None: write(_filter(_v, rawExpr=u'$schema')) # from line 764, col 5.
                            write(u''' \\
    > /dev/null || :
''')
                        write(u'''fi
''')
                    #  -Extra pre
                    if VFSL([locals()]+SL+[globals(), builtin],"has_extra_pre",True): # generated from line 770, col 1
                        write(u'''# >> pre ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 771, col 10
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 771, col 10.
                        write(u'''
''')
                        _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"pre",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]) # u'$str_newline.join($extra.content.pre[$sp.Name])' on line 772, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.pre[$sp.Name])')) # from line 772, col 1.
                        write(u'''
# << pre ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 773, col 10
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 773, col 10.
                        write(u'''
''')
                #  Preun for SubPackages
                has_extra_preun = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("preun") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.preun",True),"has_key",False)(VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True))
                if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.SystemdService",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_preun",True): # generated from line 779, col 1
                    write(u'''
%preun ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 781, col 8
                    if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 781, col 8.
                    write(u'''
''')
                    #  -Schema
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True): # generated from line 783, col 1
                        write(u'''if [ "$1" -eq 0 ]; then
''')
                        for schema in VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schemas",True): # generated from line 785, col 1
                            write(u'''  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule \\
    ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"schema",True) # u'$schema' on line 788, col 5
                            if _v is not None: write(_filter(_v, rawExpr=u'$schema')) # from line 788, col 5.
                            write(u''' \\
    > /dev/null || :
''')
                        write(u'''fi
''')
                    #  -SystemdService (systemd)
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.SystemdService",True): # generated from line 794, col 1
                        write(u'''if [ "$1" -eq 0 ]; then
''')
                        for srv in VFSL([locals()]+SL+[globals(), builtin],"sub_extra.SystemdServices",True): # generated from line 796, col 1
                            write(u'''systemctl stop ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"srv",True) # u'$srv' on line 797, col 16
                            if _v is not None: write(_filter(_v, rawExpr=u'$srv')) # from line 797, col 16.
                            write(u'''
''')
                        write(u'''fi
''')
                    #  -Extra preun
                    if VFSL([locals()]+SL+[globals(), builtin],"has_extra_preun",True): # generated from line 802, col 1
                        write(u'''# >> preun ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 803, col 12
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 803, col 12.
                        write(u'''
''')
                        _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"preun",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]) # u'$str_newline.join($extra.content.preun[$sp.Name])' on line 804, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.preun[$sp.Name])')) # from line 804, col 1.
                        write(u'''
# << preun ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 805, col 12
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 805, col 12.
                        write(u'''
''')
                #  Post for SubPackages
                has_extra_post = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("post") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.post",True),"has_key",False)(VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)) and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"post",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]
                if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Lib",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.SystemdService",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_post",True): # generated from line 811, col 1
                    write(u'''
''')
                    only_Lib = not (VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.SystemdService",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_post",True))
                    if VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 814, col 1
                        write(u'''%post ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 815, col 7
                        if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 815, col 7.
                        write(u''' -p /sbin/ldconfig
''')
                    else: # generated from line 816, col 1
                        write(u'''%post ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 817, col 7
                        if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 817, col 7.
                        write(u'''
''')
                    #  -Lib
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Lib",True) and not VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 820, col 1
                        write(u'''/sbin/ldconfig
''')
                    #  -Schema
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True): # generated from line 824, col 1
                        for schema in VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schemas",True): # generated from line 825, col 1
                            write(u'''export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule \\
    ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"schema",True) # u'$schema' on line 828, col 5
                            if _v is not None: write(_filter(_v, rawExpr=u'$schema')) # from line 828, col 5.
                            write(u'''  > /dev/null || :
''')
                    #  -Info
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Info",True): # generated from line 832, col 1
                        for inf in VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Infos",True): # generated from line 833, col 1
                            write(u'''%install_info --info-dir=%_infodir ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"inf",True) # u'$inf' on line 834, col 36
                            if _v is not None: write(_filter(_v, rawExpr=u'$inf')) # from line 834, col 36.
                            write(u'''
''')
                        #  Info
                    #  -Icon
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Icon",True): # generated from line 838, col 1
                        write(u'''/bin/touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache \\
  --quiet %{_datadir}/icons/hicolor 2> /dev/null|| :
''')
                    #  -DesktopDB
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.DesktopDB",True): # generated from line 844, col 1
                        write(u'''update-desktop-database %{_datadir}/applications &> /dev/null || :
''')
                    #  -SystemdService (systemd)
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.SystemdService",True): # generated from line 848, col 1
                        write(u'''systemctl daemon-reload
''')
                        for srv in VFSL([locals()]+SL+[globals(), builtin],"sub_extra.SystemdServices",True): # generated from line 850, col 1
                            write(u'''systemctl reload-or-try-restart ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"srv",True) # u'$srv' on line 851, col 33
                            if _v is not None: write(_filter(_v, rawExpr=u'$srv')) # from line 851, col 33.
                            write(u'''
''')
                    #  -Extra Post Script
                    if VFSL([locals()]+SL+[globals(), builtin],"has_extra_post",True): # generated from line 855, col 1
                        write(u'''# >> post ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 856, col 11
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 856, col 11.
                        write(u'''
''')
                        _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"post",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]) # u'$str_newline.join($extra.content.post[$sp.Name])' on line 857, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.post[$sp.Name])')) # from line 857, col 1.
                        write(u'''
# << post ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 858, col 11
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 858, col 11.
                        write(u'''
''')
                    #  need post
                #  PostUn for SubPackages
                has_extra_postun = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("postun") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.postun",True),"has_key",False)(VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)) and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"postun",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]
                if  VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Lib",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.SystemdService",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_postun",True): # generated from line 864, col 1
                    write(u'''
''')
                    only_Lib = not (VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.SystemdService",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_postun",True))
                    if VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 867, col 1
                        write(u'''%postun ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 868, col 9
                        if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 868, col 9.
                        write(u''' -p /sbin/ldconfig
''')
                    else: # generated from line 869, col 1
                        write(u'''%postun ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 870, col 9
                        if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 870, col 9.
                        write(u'''
''')
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Lib",True) and not VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 872, col 1
                        write(u'''/sbin/ldconfig
''')
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Info",True): # generated from line 875, col 1
                        write(u'''if [ $1 = 0 ] ;then
''')
                        for inf in VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Infos",True): # generated from line 877, col 1
                            write(u'''%install_info_delete --info-dir=%{_infodir} ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"inf",True) # u'$inf' on line 878, col 45
                            if _v is not None: write(_filter(_v, rawExpr=u'$inf')) # from line 878, col 45.
                            write(u'''
''')
                        write(u'''fi
''')
                        #  Info
                    #  -Icon
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Icon",True): # generated from line 883, col 1
                        write(u'''/bin/touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache \\
  --quiet %{_datadir}/icons/hicolor 2> /dev/null|| :
''')
                    #  -DesktopDB
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.DesktopDB",True): # generated from line 889, col 1
                        write(u'''update-desktop-database %{_datadir}/applications &> /dev/null || :
''')
                    #  -SystemdService (systemd)
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.SystemdService",True): # generated from line 893, col 1
                        write(u'''systemctl daemon-reload
''')
                    #  -Extra Postun Script
                    if VFSL([locals()]+SL+[globals(), builtin],"has_extra_postun",True): # generated from line 897, col 1
                        write(u'''# >> postun ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 898, col 13
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 898, col 13.
                        write(u'''
''')
                        _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"postun",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]) # u'$str_newline.join($extra.content.postun[$sp.Name])' on line 899, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.postun[$sp.Name])')) # from line 899, col 1.
                        write(u'''
# << postun ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 900, col 13
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 900, col 13.
                        write(u'''
''')
                    #  need postun
                #  per subpackage
            #  has subpackages
        if not VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("NoFiles"): # generated from line 905, col 1
            write(u'''
''')
            if (not VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)('LocaleFilesPkgName') or VFSL([locals()]+SL+[globals(), builtin],"metadata.LocaleFilesPkgName",True) == VFSL([locals()]+SL+[globals(), builtin],"metadata.Name",True)) and VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("LocaleName"): # generated from line 907, col 1
                write(u'''%files -f ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.LocaleName",True) # u'${metadata.LocaleName}' on line 908, col 11
                if _v is not None: write(_filter(_v, rawExpr=u'${metadata.LocaleName}')) # from line 908, col 11.
                write(u'''.lang
''')
            elif VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)('FilesInput'): # generated from line 909, col 1
                write(u'''%files -f ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.FilesInput",True) # u'$metadata.FilesInput' on line 910, col 11
                if _v is not None: write(_filter(_v, rawExpr=u'$metadata.FilesInput')) # from line 910, col 11.
                write(u'''
''')
            else: # generated from line 911, col 1
                write(u'''%files
''')
            write(u'''%defattr(-,root,root,-)
''')
            #  TODO to be cleanup
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Documents"): # generated from line 916, col 1
                for doc in VFSL([locals()]+SL+[globals(), builtin],"metadata.Documents",True): # generated from line 917, col 1
                    write(u'''%doc ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"doc",True) # u'$doc' on line 918, col 6
                    if _v is not None: write(_filter(_v, rawExpr=u'$doc')) # from line 918, col 6.
                    write(u'''
''')
            if "Files" in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 921, col 1
                for f in VFSL([locals()]+SL+[globals(), builtin],"metadata.Files",True): # generated from line 922, col 1
                    _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"f",True)) # u'$arch_line($f)' on line 923, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($f)')) # from line 923, col 1.
                    write(u'''
''')
            write(u'''# >> files
''')
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("files") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.files",True),"has_key",False)("main"): # generated from line 927, col 1
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.files.main",True)) # u'$str_newline.join($extra.content.files.main)' on line 928, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.files.main)')) # from line 928, col 1.
                write(u'''
''')
            write(u'''# << files
''')
            #  not NoFiles
        #  files for subpkgs
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("SubPackages"): # generated from line 933, col 1
            for sp in VFSL([locals()]+SL+[globals(), builtin],"metadata.SubPackages",True): # generated from line 934, col 1
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("AsWholeName"): # generated from line 935, col 1
                    pkg_name = "-n " + VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)
                else: # generated from line 937, col 1
                    pkg_name = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)
                write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("LocaleName") and VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)('LocaleFilesPkgName') and VFSL([locals()]+SL+[globals(), builtin],"metadata.LocaleFilesPkgName",True) == VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True): # generated from line 941, col 1
                    write(u'''%files ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 942, col 8
                    if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 942, col 8.
                    write(u''' -f ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.LocaleName",True) # u'${metadata.LocaleName}' on line 942, col 21
                    if _v is not None: write(_filter(_v, rawExpr=u'${metadata.LocaleName}')) # from line 942, col 21.
                    write(u'''.lang
''')
                elif VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)('FilesInput'): # generated from line 943, col 1
                    write(u'''%files ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 944, col 8
                    if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 944, col 8.
                    write(u''' -f ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.FilesInput",True) # u'$sp.FilesInput' on line 944, col 21
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.FilesInput')) # from line 944, col 21.
                    write(u'''
''')
                else: # generated from line 945, col 1
                    write(u'''%files ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 946, col 8
                    if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 946, col 8.
                    write(u'''
''')
                write(u'''%defattr(-,root,root,-)
''')
                #  TODO to be cleanup
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Documents"): # generated from line 950, col 1
                    for doc in VFSL([locals()]+SL+[globals(), builtin],"sp.Documents",True): # generated from line 951, col 1
                        write(u'''%doc ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"doc",True) # u'$doc' on line 952, col 6
                        if _v is not None: write(_filter(_v, rawExpr=u'$doc')) # from line 952, col 6.
                        write(u'''
''')
                if "Files" in VFSL([locals()]+SL+[globals(), builtin],"sp",True): # generated from line 955, col 1
                    for f in VFSL([locals()]+SL+[globals(), builtin],"sp.Files",True): # generated from line 956, col 1
                        _v = VFSL([locals()]+SL+[globals(), builtin],"arch_line",False)(VFSL([locals()]+SL+[globals(), builtin],"f",True)) # u'$arch_line($f)' on line 957, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$arch_line($f)')) # from line 957, col 1.
                        write(u'''
''')
                write(u'''# >> files ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 960, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 960, col 12.
                write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("files") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.files",True),"has_key",False)(VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)): # generated from line 961, col 1
                    _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"files",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]) # u'$str_newline.join($extra.content.files[$sp.Name])' on line 962, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.files[$sp.Name])')) # from line 962, col 1.
                    write(u'''
''')
                write(u'''# << files ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 964, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 964, col 12.
                write(u'''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_spec = 'respond'

## END CLASS DEFINITION

if not hasattr(spec, '_initCheetahAttributes'):
    templateAPIClass = getattr(spec,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(spec)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=spec()).run()


